#ifndef DEFFMAS_H
#define DEFFMAS_H

#include "formulas.h"
#include <vector>

class Literal: public Formula {
  int value_;
 public:
  Literal(int value);
  FormulaId classId() const;
  void clear();
  int count() const;
  int value() const;
  bool polarity() const;
  void push(Formula* child);
  Formula* pop();
  Formula* clone() const;
  const Formula& operator[](int index) const;
  Formula& operator[](int index);
};

class Junction: public Formula {
  std::vector<Formula*> childs;
  bool polarity_;
 public:
  Junction(bool polarity);
  Junction(Formula* child, bool polarity);
  ~Junction();
  FormulaId classId() const;
  void clear();
  int count() const;
  int value() const;
  bool polarity() const;
  void push(Formula* child);
  Formula* pop();
  Formula* clone() const;
  const Formula& operator[](int index) const;
  Formula& operator[](int index);
};

#endif // DEFFMAS_H
