#ifndef UTILS_H
#define UTILS_H

#include <string>
#include <sstream>
#include <stdexcept>

typedef unsigned int uint;

// misselaneous random things
inline int randInt(int value) { return rand()%value; }
inline uint randseed() { return time(NULL) + getpid(); }
// tip on seeds: http://www.itworld.com/nl/lnx_tip/03232001/
// % even some entropy hints! cool!

// string manipulation
std::string search_replace(const std::string& source,
  const std::string& search, const std::string& replace);


template<class T>
std::string stringify(const T& value) {
  std::ostringstream os;
  os << value;
  return os.str();
}

template<class T>
T unstring(const std::string& value, const std::string& msg = "") {
  std::istringstream is(value);
  T result;
  if (!(is >> result)) {
    if (msg!="") throw std::runtime_error(search_replace(msg, "%s", value));
    result = T();
  }
  return result;
}

inline std::string& nice_append(std::string& s, const std::string& append,
  const std::string& separator = ", ")
{
  if (s!="") s+= separator;
  s+= append;
  return s;
}

std::string get_token(std::string& s, char delimiter = '|');
std::string get_token(std::string& s, const std::string& delimiter);

int select(const std::string& s, const std::string& list,
	   char delimiter = '|');

#endif // UTILS_H
